<p class="markdown-content" ref:mountpoint>
  <!-- {@html htmlContent} -->
</p>

<script>
  import SimpleMarkdown from "simple-markdown";
  import EmojiUtils from "../js/EmojiUtils";
  import UserStore from "../stores/UserStore";
  import ChannelStore from "../stores/ChannelStore";
  import TokenStore from "../js/TokenStore";

  import TextRule from "./rules/TextRule.svelte";
  import ParagraphRule from "./rules/ParagraphRule.svelte";
  import NewlineRule from "./rules/ParagraphRule.svelte";
  import LinkRule from "./rules/LinkRule.svelte";
  import StrongRule from "./rules/StrongRule.svelte";
  import EMRule from "./rules/EMRule.svelte";
  import URule from "./rules/URule.svelte";
  import BRRule from "./rules/BRRule.svelte";
  import InlineCodeRule from "./rules/InlineCodeRule.svelte";
  import StrikeThruRule from "./rules/StrikeThruRule.svelte";
  import UserMentionRule from "./rules/UserMentionRule.svelte";
  import ChannelMentionRule from "./rules/ChannelMentionRule.svelte";
  import EmojiRule from "./rules/EmojiRule.svelte";

  window.smd = SimpleMarkdown;

  function createFragment() {
    return document.createDocumentFragment();
  }

  function outputFor(RuleComponent, noRecurse) {
    return function svelteMaker(node, output, state) {
      // console.log("svelteMaker()", state);
      let slotComponents = noRecurse
        ? noRecurse === true
          ? node.content
          : noRecurse(node.content)
        : output(node.content, state);
      if (!Array.isArray(slotComponents)) slotComponents = [slotComponents];
      const component = new RuleComponent({
        slots: {
          default: slotComponents && slotComponents.length && createFragment()
        },
        data: node,
        root: state.root,
        store: state.root.store
      });
      // Generates elems
      // console.log("Component", component);
      component._fragment.c();
      if (component._slotted) {
        for (const slotComponent of slotComponents) {
          if (typeof slotComponent == "string") {
            const text = document.createTextNode(slotComponent);
            component._slotted.default.appendChild(text);
          } else {
            slotComponent._mount(component._slotted.default, null);
          }
        }
      }
      return component;
    };
  }

  function extendRule(rule, RuleComponent, noRecurse) {
    // console.log("EXTENDING", rule, rule.html);
    if (RuleComponent) rule.svelte = outputFor(RuleComponent, noRecurse);
    else rule.svelte = null;
    return rule;
  }

  function svelteFor(outputFunc) {
    let state = null;
    function nestedOutput(ast, updatedState) {
      // console.log("nestedOutput!", updatedState, state);
      state = updatedState || state;
      // console.log("nestedOutput(ast, state)", ast, state);
      if (Array.isArray(ast)) {
        const result = [];
        let lastResult = null;
        for (let i = 0; i < ast.length; i++) {
          // state.key = '' + i;
          const nodeOut = nestedOutput(ast[i], state);
          if (typeof nodeOut == "string" && typeof lastResult == "string") {
            lastResult += nodeOut;
            result[result.length - 1] = lastResult;
          } else {
            result.push(nodeOut);
            lastResult = nodeOut;
          }
          result.push(nodeOut);
        }
        return result;
      } else {
        // console.log("One component rendering!", outputFunc, ast, nestedOutput, state);
        return outputFunc(ast, nestedOutput, state);
      }
    }
    return nestedOutput;
  }

  const ruleSets = {
    standard: {
      text: extendRule(SimpleMarkdown.defaultRules.text, TextRule, true),
      paragraph: extendRule(SimpleMarkdown.defaultRules.paragraph, ParagraphRule),
      newline: extendRule(SimpleMarkdown.defaultRules.newline, NewlineRule),
      escape: extendRule(SimpleMarkdown.defaultRules.escape, null),
      link: extendRule(SimpleMarkdown.defaultRules.link, LinkRule),
      autolink: extendRule(SimpleMarkdown.defaultRules.autolink, null),
      url: extendRule(SimpleMarkdown.defaultRules.url, null),
      strong: extendRule(SimpleMarkdown.defaultRules.strong, StrongRule),
      em: extendRule(SimpleMarkdown.defaultRules.em, EMRule),
      u: extendRule(SimpleMarkdown.defaultRules.u, URule),
      br: extendRule(SimpleMarkdown.defaultRules.br, BRRule, true),
  
      inlineCode: extendRule(
        SimpleMarkdown.defaultRules.inlineCode,
        InlineCodeRule,
        true
      ),
  
      s: {
        order: SimpleMarkdown.defaultRules.u.order,
        match: SimpleMarkdown.inlineRegex(/^~~([\s\S]+?)~~(?!_)/),
        parse: SimpleMarkdown.defaultRules.u.parse,
        html: function(node, output, state) {
          return SimpleMarkdown.htmlTag("s", output(node.content, state));
        },
        svelte: outputFor(StrikeThruRule)
      },

      mention: {
        order: SimpleMarkdown.defaultRules.u.order + 1,
        match: function(text) {
          return text.match(/^<@(\d+)>/) || text.match(/^@everyone/);
        },
        parse: function(capture) {
          const userId = capture[1];
          const user = userId && UserStore.getUser(userId);
          return {
            id: capture[1],
            whole: capture[0],
            content: {
              type: "text",
              content: user ? "@" + user.username : capture[0]
            }
          };
        },
        html: function(node) {
          const className =
            "mention" +
            (node.id === TokenStore.getUserIdSync() ? " mentions-user" : "");
          const html = SimpleMarkdown.htmlTag(
            "span",
            SimpleMarkdown.sanitizeText(node.displayName),
            {
              class: className
            }
          );
          return html;
        },
        svelte: outputFor(UserMentionRule)
      },

      channelMention: {
        order: SimpleMarkdown.defaultRules.u.order + 2,
        match: function(text) {
          return text.match(/^<#(\d+)>/);
        },
        parse: function(capture) {
          const channelId = capture[1];
          const channel = channelId && ChannelStore.getChannel(channelId);
          return {
            id: channelId,
            content: {
              type: "text",
              content: channel ? "#" + channel.name : capture[0]
            }
          };
        },
        html: function(node) {
          const html = SimpleMarkdown.htmlTag(
            "span",
            SimpleMarkdown.sanitizeText(node.displayName),
            {
              class: "channel-mention"
            }
          );
          return html;
        },
        svelte: outputFor(ChannelMentionRule, true)
      },
  
      emoji: {
        order: SimpleMarkdown.defaultRules.u.order + 3,
        match: function(source, state) {
          if (!state.inline) return null;
          // SimpleMarkdown.inlineRegex()
          const results = /^:([a-z0-9_]{2,32}):/.exec(source);
          if (!results) return null;
          else {
            if (EmojiUtils.urlFor(results[1])) return results;
            else return null;
          }
        },
        parse: function(capture) {
          const url = EmojiUtils.urlFor(capture[1]);
          if (url)
            return {
              alt: ":" + capture[1] + ":",
              target: url
            };
          else return null;
        },
        html: function(node) {
          return SimpleMarkdown.htmlTag(
            "img",
            "",
            {
              src: SimpleMarkdown.sanitizeUrl(node.target),
              alt: node.alt,
              class: "emoji"
            },
            false
          );
        },
        svelte: outputFor(EmojiRule, true)
      }
    }
  };
  const markdownSets = {
    standard: {
      parse: SimpleMarkdown.parserFor(ruleSets.standard),
      output: svelteFor(SimpleMarkdown.ruleOutput(ruleSets.standard, "svelte"))
      // output: SimpleMarkdown.htmlFor(SimpleMarkdown.ruleOutput(ruleSets.stasndard, "html"))
    } //,
    /*message: {
      parse: SimpleMarkdown.parserFor(ruleSets.message),
      output: SimpleMarkdown.htmlFor(SimpleMarkdown.ruleOutput(ruleSets.message, "html"))
    }*/
  };

  function parse(content, parser, root) {
    if (!parser) parser = "standard";
    const state = {
      inline: true,
      mountables: {},
      root
    };
    // console.log("We have a state, right?", state);
    return markdownSets[parser].output(
      markdownSets[parser].parse(content, state),
      state
    );
  }
  
  export default {
    oncreate() {
      for (const upperComponent of this._upperComponents) {
        // console.log(upperComponent, this);
        upperComponent._mount(this.refs.mountpoint, null);
      }
    },
    ondestroy() {
      if (this._upperComponents) {
        for (const upperComponent of this._upperComponents) {
          upperComponent.destroy();
        }
        while (this.refs.mountpoint.lastChild) {
          this.refs.mountpoint.lastChild.remove();
        }
      }
    },
    onstate({current, changed}) {
      if (changed.content || changed.parser) {
        if (this._upperComponents) {
          for (const upperComponent of this._upperComponents) {
            try {
              upperComponent.destroy();
            } catch (err) {
              console.error(err);
            }
          }
          while (this.refs.mountpoint.lastChild) {
            this.refs.mountpoint.lastChild.remove();
          }
        }
        let upperComponents = parse(current.content, current.parser, this.root);
        if (!Array.isArray(upperComponents)) upperComponents = [upperComponents];

        this._upperComponents = upperComponents;
        if (this.refs.mountpoint) {
          for (const upperComponent of upperComponents) {
            // console.log(upperComponent, this);
            upperComponent._mount(this.refs.mountpoint);
          }
        }
      }
    }
  };
</script>

<style>
  .markdown-content {
    margin: 0;
    white-space: pre-wrap;
    word-wrap: break-word;
    color: #dcddde;
  }
</style>
